definition module Internet.HTTP.TCPIP

/**
 * This module provides functions to do HTTP requests using the TCPIP library.
 */

from Data.Error import :: MaybeError, :: MaybeErrorString
from Internet.HTTP import :: HTTPRequest, :: HTTPResponse

/**
 * Do an HTTP request and return the response.
 *
 * @param The request
 * @param Timeout in milliseconds
 * @param The world
 * @result The response
 * @result The world
 */
doHTTPRequest :: !HTTPRequest Int !*World -> *(!MaybeErrorString HTTPResponse, !*World)

/**
 * Do an HTTP request and follow redirects (http codes 301, 302, 303, 307, 308).
 *
 * @param The request
 * @param Timeout in milliseconds
 * @param The maximum number of redirects to follow
 * @param The world
 * @result The response
 * @result The world
 */
doHTTPRequestFollowRedirects :: !HTTPRequest Int !Int !*World -> *(!MaybeErrorString HTTPResponse, !*World)
